;MOHR.LSP   copyright 1988  Mehrdad Soltani

(defun C:MOHR()
   (setvar "CMDECHO" 0)
   (setq base (getpoint "Locate plot origin: "))
   (setq sig1 (getdist  "Enter x: "))
   (setq sig2 (getdist  "Enter y: "))
   (setq tau  (getdist  "Enter xy: "))
   (setq sigm (/ (+ sig1 sig2) 2))
   (setq s1   (list (+ (nth 0 base) sig1) (- (nth 1 base) tau)))
   (setq s2   (list (+ (nth 0 base) sig2) (+ (nth 1 base) tau)))
   (setq tmax (/ (distance s1 s2) 2))
   (command "line" s1 s2 "")
   (command "line" s1 (list (nth 0 s1) (nth 1 base)) "")
   (command "line" s2 (list (nth 0 s2) (nth 1 base)) "")
   (setq axis (* sigm 2))
   (setq endx (list (+ (nth 0 base) axis) (nth 1 base)))
   (setq topy (list (nth 0 base) (+ (nth 1 base) sigm)))
   (setq boty (list (nth 0 base) (- (nth 1 base) sigm)))
   (setq len  (sqrt (- (* sigm sigm) (* tmax tmax))))
   (setq phi  (angtos (atan tmax len) 0 3))
   (command "line" topy boty "")
   (command "line" base endx "")
   (command "circle" (list (+ (nth 0 base) sigm) (nth 1 base)) tmax)
   (command "line" (list (+ (nth 0 base) sigm) (+ (nth 1 base) tmax))
	           (list (+ (nth 0 base) sigm) (- (nth 1 base) tmax)) "")
   (setq len (rtos (* len 2.5) 2 3))
   (setq vect (strcat "@" len "<" phi))
   (command "line" base vect "")
   (setq stext (list (- (nth 0 base) (/ tmax 10)) (- (nth 1 base) (/ tmax 20))))
   (command "text" stext (/ tmax 10) 0 "0")
   (setq stext (list (- (nth 0 endx) (/ tmax 2.5)) (- (nth 1 endx) (/ tmax 6))))
   (command "text" stext (/ tmax 10) 0 " Axial")
   (setq stext (list (- (nth 0 topy) (/ tmax 10)) (- (nth 1 topy) (/ tmax 2.5))))
   (command "text" stext (/ tmax 10) 90 " Shear")
   (setq stext (list (+ (nth 0 base) sigm) (+ (nth 1 base) (* tmax 1.05))))
   (command "text" stext (/ tmax 10) 0 "T max")
   (setq stext (list (+ (nth 0 base) sigm) (- (nth 1 base) (* tmax 1.15))))
   (command "text" stext (/ tmax 10) 0 "T min")
   (setq stext (list (- (nth 0 base) (* tmax 4)) (nth 1 base)))
   (command "text" stext (/ tmax 10) 0 (strcat "Maximum stress = " (rtos (+ sigm tmax) 2 3)))
   (command "text" "" (strcat "Minimum stress = " (rtos (- sigm tmax) 2 3)))
   (command "text" "" "   ")
   (command "text" "" (strcat "Normal stress        = " (rtos sigm 2 3)))
   (command "text" "" (strcat "Maximum shear stress = " (rtos tmax 2 3)))
   (command "text" "" (strcat "Angle of friction    = " phi " degrees"))
   (command "text" "" "   ")
   (command "text" "" "Inputs:")
   (command "text" "" (strcat "Stress along X dir. = " (rtos sig1 2 3)))
   (command "text" "" (strcat "Stress along Y dir. = " (rtos sig2 2 3)))
   (command "text" "" (strcat "Shear XY and YX     = " (rtos tau 2 3)))
)

